<mat-toolbar color="primary">
  <span>Angular CRUD</span>
</mat-toolbar>

<div class="container">
  <form
    [formGroup]="itemForm"
    (ngSubmit)="submitItemForm()"
    class="mat-elevation-z8"
    *ngIf="showUi"
  >
    <h1>Add & Update Form</h1>
    <mat-form-field appearance="outline">
      <mat-label>Name</mat-label>
      <input matInput formControlName="name" placeholder="Item Name" />
      <mat-icon matSuffix>production_quantity_limits</mat-icon>
      <mat-hint>Max characters: 20</mat-hint>
      <mat-error
        *ngIf="
          itemForm.controls.name.errors &&
          itemForm.controls.name.errors.required
        "
        >This should not be empty.</mat-error
      >
      <mat-error
        *ngIf="
          itemForm.controls.name.errors &&
          itemForm.controls.name.errors.maxlength
        "
        >Max length is
        {{ itemForm.controls.name.errors.maxlength.requiredLength }}. Yours is
        {{ itemForm.controls.name.errors.maxlength.actualLength }}</mat-error
      >
    </mat-form-field>

    <mat-form-field appearance="outline">
      <mat-label>Price</mat-label>
      <input
        type="number"
        matInput
        formControlName="price"
        placeholder="Item price"
      />
      <mat-icon matSuffix>request_quote</mat-icon>
      <mat-hint>Max Price: 1000</mat-hint>
      <mat-error
        *ngIf="
          itemForm.controls.price.errors &&
          itemForm.controls.price.errors.required
        "
        >This should not be empty.</mat-error
      >
      <mat-error
        *ngIf="
          itemForm.controls.price.errors && itemForm.controls.price.errors.max
        "
        >Max value is {{ itemForm.controls.price.errors.max.max }}. Yours is
        {{ itemForm.controls.price.errors.max.actual }}
      </mat-error>
    </mat-form-field>

    <mat-form-field appearance="outline">
      <mat-label>Description</mat-label>
      <textarea
        matInput
        formControlName="description"
        placeholder="Item description"
        cdkTextareaAutosize
        cdkAutosizeMinRows="3"
        cdkAutosizeMaxRows="10"
      ></textarea>
      <mat-icon matSuffix>info</mat-icon>
      <mat-hint>Short info about the item</mat-hint>
      <mat-error
        *ngIf="
          itemForm.controls.description.errors &&
          itemForm.controls.description.errors.required
        "
        >This should not be empty.</mat-error
      >
    </mat-form-field>

    <mat-form-field appearance="outline">
      <mat-label>Image URL</mat-label>
      <input matInput formControlName="imageUrl" placeholder="Item Image URL" />
      <mat-icon matSuffix>perm_media</mat-icon>
      <mat-hint>Ex: https://yourimageurl.com</mat-hint>
      <mat-error
        *ngIf="
          itemForm.controls.imageUrl.errors &&
          itemForm.controls.imageUrl.errors.required
        "
        >This should not be empty.</mat-error
      >
    </mat-form-field>

    <button
      *ngIf="!itemForm.controls._id; else updateButtons"
      mat-raised-button
      color="primary"
    >
      Add
    </button>
    <ng-template #updateButtons>
      <div class="update-buttons">
        <button mat-raised-button color="accent">Update</button>
        <button
          type="button"
          mat-raised-button
          color="warn"
          (click)="cancelUpdate()"
        >
          Cancel
        </button>
      </div>
    </ng-template>
  </form>

  <div class="data-table" [hidden]="!dataSource || !showUi">
    <mat-form-field>
      <mat-label>Filter</mat-label>
      <input
        matInput
        (keyup)="applyFilter($event)"
        placeholder="Ex. Mia"
        #input
      />
    </mat-form-field>

    <button
      *ngIf="selection.selected.length"
      (click)="deleteItems()"
      mat-raised-button
      color="warn"
    >
      Delete
    </button>

    <div class="mat-elevation-z8">
      <table mat-table [dataSource]="dataSource" matSort>
        <ng-container matColumnDef="select">
          <th mat-header-cell *matHeaderCellDef>
            <mat-checkbox
              (change)="$event ? masterToggle() : null"
              [checked]="selection.hasValue() && isAllSelected()"
              [indeterminate]="selection.hasValue() && !isAllSelected()"
            >
            </mat-checkbox>
          </th>
          <td mat-cell *matCellDef="let row">
            <mat-checkbox
              (click)="$event.stopPropagation()"
              (change)="$event ? selection.toggle(row) : null"
              [checked]="selection.isSelected(row)"
            >
            </mat-checkbox>
          </td>
        </ng-container>

        <ng-container matColumnDef="name">
          <th mat-header-cell *matHeaderCellDef mat-sort-header>Name</th>
          <td mat-cell *matCellDef="let row" (click)="viewFullItemDetails(row)">
            {{ row.name }}
          </td>
        </ng-container>

        <ng-container matColumnDef="price">
          <th mat-header-cell *matHeaderCellDef mat-sort-header>Price</th>
          <td mat-cell *matCellDef="let row" (click)="viewFullItemDetails(row)">
            {{ row.price }}
          </td>
        </ng-container>

        <ng-container matColumnDef="update">
          <th mat-header-cell *matHeaderCellDef>Update</th>
          <td mat-cell *matCellDef="let row" (click)="setUpdateItem(row)">
            <button mat-mini-fab color="accent">
              <mat-icon>edit</mat-icon>
            </button>
          </td>
        </ng-container>

        <tr mat-header-row *matHeaderRowDef="displayedColumns"></tr>
        <tr mat-row *matRowDef="let row; columns: displayedColumns"></tr>

        <tr class="mat-row" *matNoDataRow>
          <td class="mat-cell" colspan="4">
            No data matching the filter "{{ input.value }}"
          </td>
        </tr>
      </table>

      <mat-paginator
        [pageSizeOptions]="[5, 10, 20]"
        showFirstLastButtons
      ></mat-paginator>
    </div>
  </div>
</div>
